/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import io.docs_dispatcher.client.JSON;

/**
 * Specific object to format anchors that have to be parsed into documents for example to display user&#39;s signature
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-23T16:40:16.535479755Z[Etc/UTC]", comments = "Generator version: 7.5.0-SNAPSHOT")
public class ESignField {
  public static final String SERIALIZED_NAME_RECIPIENT = "recipient";
  @SerializedName(SERIALIZED_NAME_RECIPIENT)
  private String recipient;

  public static final String SERIALIZED_NAME_ANCHOR_KEY = "anchorKey";
  @SerializedName(SERIALIZED_NAME_ANCHOR_KEY)
  private String anchorKey;

  /**
   * The anchor type. Usefull only for for building the json path to that anchor so as the document can be generated with the anchor.
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    SIGNATURE("SIGNATURE"),
    
    VISA("VISA");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return TypeEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      TypeEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private TypeEnum type;

  public static final String SERIALIZED_NAME_ADDITIONAL_OPTIONS = "additionalOptions";
  @SerializedName(SERIALIZED_NAME_ADDITIONAL_OPTIONS)
  private String additionalOptions;

  public static final String SERIALIZED_NAME_CONSENTS = "consents";
  @SerializedName(SERIALIZED_NAME_CONSENTS)
  private List<String> consents = new ArrayList<>();

  public ESignField() {
  }

  public ESignField recipient(String recipient) {
    this.recipient = recipient;
    return this;
  }

   /**
   * Recipient field for internal identifier. Usefull for request scoped references.
   * @return recipient
  **/
  @javax.annotation.Nonnull
  public String getRecipient() {
    return recipient;
  }

  public void setRecipient(String recipient) {
    this.recipient = recipient;
  }


  public ESignField anchorKey(String anchorKey) {
    this.anchorKey = anchorKey;
    return this;
  }

   /**
   * The key for building the json path to that anchor so as the document can be generated with the anchor.
   * @return anchorKey
  **/
  @javax.annotation.Nullable
  public String getAnchorKey() {
    return anchorKey;
  }

  public void setAnchorKey(String anchorKey) {
    this.anchorKey = anchorKey;
  }


  public ESignField type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The anchor type. Usefull only for for building the json path to that anchor so as the document can be generated with the anchor.
   * @return type
  **/
  @javax.annotation.Nullable
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }


  public ESignField additionalOptions(String additionalOptions) {
    this.additionalOptions = additionalOptions;
    return this;
  }

   /**
   * The anchor optional additional settings to be printed into the document
   * @return additionalOptions
  **/
  @javax.annotation.Nullable
  public String getAdditionalOptions() {
    return additionalOptions;
  }

  public void setAdditionalOptions(String additionalOptions) {
    this.additionalOptions = additionalOptions;
  }


  public ESignField consents(List<String> consents) {
    this.consents = consents;
    return this;
  }

  public ESignField addConsentsItem(String consentsItem) {
    if (this.consents == null) {
      this.consents = new ArrayList<>();
    }
    this.consents.add(consentsItem);
    return this;
  }

   /**
   * List of anchor associated consents to display to the user
   * @return consents
  **/
  @javax.annotation.Nullable
  public List<String> getConsents() {
    return consents;
  }

  public void setConsents(List<String> consents) {
    this.consents = consents;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ESignField esignField = (ESignField) o;
    return Objects.equals(this.recipient, esignField.recipient) &&
        Objects.equals(this.anchorKey, esignField.anchorKey) &&
        Objects.equals(this.type, esignField.type) &&
        Objects.equals(this.additionalOptions, esignField.additionalOptions) &&
        Objects.equals(this.consents, esignField.consents);
  }

  @Override
  public int hashCode() {
    return Objects.hash(recipient, anchorKey, type, additionalOptions, consents);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ESignField {\n");
    sb.append("    recipient: ").append(toIndentedString(recipient)).append("\n");
    sb.append("    anchorKey: ").append(toIndentedString(anchorKey)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    additionalOptions: ").append(toIndentedString(additionalOptions)).append("\n");
    sb.append("    consents: ").append(toIndentedString(consents)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("recipient");
    openapiFields.add("anchorKey");
    openapiFields.add("type");
    openapiFields.add("additionalOptions");
    openapiFields.add("consents");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("recipient");
  }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to ESignField
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      if (jsonElement == null) {
        if (!ESignField.openapiRequiredFields.isEmpty()) { // has required fields but JSON element is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ESignField is not found in the empty JSON string", ESignField.openapiRequiredFields.toString()));
        }
      }

      Set<Map.Entry<String, JsonElement>> entries = jsonElement.getAsJsonObject().entrySet();
      // check to see if the JSON string contains additional fields
      for (Map.Entry<String, JsonElement> entry : entries) {
        if (!ESignField.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ESignField` properties. JSON: %s", entry.getKey(), jsonElement.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : ESignField.openapiRequiredFields) {
        if (jsonElement.getAsJsonObject().get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonElement.toString()));
        }
      }
        JsonObject jsonObj = jsonElement.getAsJsonObject();
      if (!jsonObj.get("recipient").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `recipient` to be a primitive type in the JSON string but got `%s`", jsonObj.get("recipient").toString()));
      }
      if ((jsonObj.get("anchorKey") != null && !jsonObj.get("anchorKey").isJsonNull()) && !jsonObj.get("anchorKey").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `anchorKey` to be a primitive type in the JSON string but got `%s`", jsonObj.get("anchorKey").toString()));
      }
      if ((jsonObj.get("type") != null && !jsonObj.get("type").isJsonNull()) && !jsonObj.get("type").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `type` to be a primitive type in the JSON string but got `%s`", jsonObj.get("type").toString()));
      }
      // validate the optional field `type`
      if (jsonObj.get("type") != null && !jsonObj.get("type").isJsonNull()) {
        TypeEnum.validateJsonElement(jsonObj.get("type"));
      }
      if ((jsonObj.get("additionalOptions") != null && !jsonObj.get("additionalOptions").isJsonNull()) && !jsonObj.get("additionalOptions").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `additionalOptions` to be a primitive type in the JSON string but got `%s`", jsonObj.get("additionalOptions").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("consents") != null && !jsonObj.get("consents").isJsonNull() && !jsonObj.get("consents").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `consents` to be an array in the JSON string but got `%s`", jsonObj.get("consents").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ESignField.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ESignField' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ESignField> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ESignField.class));

       return (TypeAdapter<T>) new TypeAdapter<ESignField>() {
           @Override
           public void write(JsonWriter out, ESignField value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ESignField read(JsonReader in) throws IOException {
             JsonElement jsonElement = elementAdapter.read(in);
             validateJsonElement(jsonElement);
             return thisAdapter.fromJsonTree(jsonElement);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ESignField given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ESignField
  * @throws IOException if the JSON string is invalid with respect to ESignField
  */
  public static ESignField fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ESignField.class);
  }

 /**
  * Convert an instance of ESignField to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

